package sun.security.tools.policytool;

import sun.security.provider.PolicyParser;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import java.text.MessageFormat;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

class AddEntryDoneButtonListener implements ActionListener
{
    private PolicyTool tool;
    private ToolWindow tw;
    private ToolDialog td;
    private boolean edit;
    
    AddEntryDoneButtonListener(PolicyTool tool, ToolWindow tw, ToolDialog td, boolean edit) {
        this.tool = tool;
        this.tw = tw;
        this.td = td;
        this.edit = edit;
    }
    
    @Override
    public void actionPerformed(ActionEvent actionEvent) {
        try {
            PolicyEntry policyEntryFromDialog = this.td.getPolicyEntryFromDialog();
            PolicyParser.GrantEntry grantEntry = policyEntryFromDialog.getGrantEntry();
            if (grantEntry.signedBy != null) {
                String[] signers = this.tool.parseSigners(grantEntry.signedBy);
                for (int i = 0; i < signers.length; ++i) {
                    if (this.tool.getPublicKeyAlias(signers[i]) == null) {
                        MessageFormat o = new MessageFormat(PolicyTool.getMessage("Warning.A.public.key.for.alias.signers.i.does.not.exist.Make.sure.a.KeyStore.is.properly.configured."));
                        Object[] array = { signers[i] };
                        this.tool.warnings.addElement(o.format(array));
                        this.tw.displayStatusDialog(this.td, o.format(array));
                    }
                }
            }
            JList<Object> list = (JList)this.tw.getComponent(3);
            if (this.edit) {
                int selectedIndex = list.getSelectedIndex();
                this.tool.addEntry(policyEntryFromDialog, selectedIndex);
                String headerToString = policyEntryFromDialog.headerToString();
                if (PolicyTool.collator.compare(headerToString, list.getModel().getElementAt(selectedIndex)) != 0) {
                    this.tool.modified = true;
                }
                ((DefaultListModel)list.getModel()).set(selectedIndex, headerToString);
            }
            else {
                this.tool.addEntry(policyEntryFromDialog, -1);
                ((DefaultListModel)list.getModel()).addElement(policyEntryFromDialog.headerToString());
                this.tool.modified = true;
            }
            this.td.setVisible(false);
            this.td.dispose();
        }
        catch (Exception ex) {
            this.tw.displayErrorDialog(this.td, ex);
        }
    }
}
